#include "scalec8.h"

void scalec8(register complex8 *a,register int n,register real8 scale)
{
  register real8 t1, t2, t3, t4;

  if (n & 1) {
    t1 = a[0].re;
    t1 *= scale;
    t2 = a[0].im;
    t2 *= scale;
    a[0].re = t1;
    a[0].im = t2;

    ++a; --n;
  }

  while (n > 0) {
    t1 = a[0].re;
    t1 *= scale;
    t2 = a[0].im;
    t2 *= scale;
    t3 = a[1].re;
    t3 *= scale;
    t4 = a[1].im;
    t4 *= scale;
    a[0].re = t1;
    a[0].im = t2;
    a[1].re = t3;
    a[1].im = t4;

    a += 2; n -= 2;
  }
}
